;*****************************************************************************
; DOS/32 Advanced Example Files Collection
; Copyright (C) 1996-1998 Supernar Systems, Intl.
; All Rights Reserved.
;
; MEMERR.ASM
; This program shows how the DOS Extender keeps track on whether the Extended
; memory blocks are valid or they have been corrupted (overwritten).
; NOTE: this program will not work under external DPMI.
;
;*****************************************************************************

	.386p
	.MODEL flat

DGROUP	group _DATA,STACK		; Tasm will complain about STACK here

.CODE
;=============================================================================
start:
	push	ds			; make ES=DS
	pop	es

	mov	ax,0FF91h		; allocate memory (use DOS/32 Advanced
	mov	ebx,1000h		;  specific mem allocation functions)
	int	21h

	mov	edi,ebx			; fill memory with 0FFh
	mov	ecx,1001h		; Note: 1000h + 1 bytes to force
	mov	eax,-1			;  overwriting of next block header
	rep	stosb

				; Note: the DOS Extender cannot detect that
				; memory blocks have been corrupted unless
				; you call an extended memory related DPMI
				; function (any 05xxh function will do)
				
	mov	ax,0FF92h		; try to deallocate memory
	int	21h			;  at this point DOS/32 Advanced will
					;  terminate the application with an
					;  error

	mov	ah,9			; this code should never be executed
	mov	edx,offset _str1
	int	21h
	mov	ax,4C00h
	int	21h


.DATA
;=============================================================================
_str1	db 0Dh,0Ah
	db 'You should never see this!!!',0Dh,0Ah,'$'


.STACK
;=============================================================================
	db	1000h dup(?)


end	start
