/*****************************************************************************
 DOS/32 Advanced Example Files Collection
 Copyright (C) 1996-1998 Supernar Systems, Intl.
 All Rights Reserved.

 PROG2.C
 See SPAWN.C

*****************************************************************************/


	unsigned char CpuType;
	unsigned char SysType;

struct memory {
	unsigned long LargestFreeBlock;
	unsigned long MaxUnlockedPages;
	unsigned long MaxLockedPages;
	unsigned long LinearSpaceInPages;
	unsigned long TotalNumOfUnlockedPages;
	unsigned long TotalNumOfFreePages;
	unsigned long TotalNumOfPhysPages;
	unsigned long FreeLinearSpaceInPages;
	unsigned long SizeOfPagingFile;
	unsigned long Reserved[3];
} Mem;


#pragma aux getmem =			\
	"mov	eax,0500h"		\
	"mov	edi,offset Mem"		\
	"int	31h"			\
	modify [eax edi];

#pragma aux getinfo =			\
	"push	fs"			\
	"mov	eax,0FF8Ah"		\
	"int	21h"			\
	"mov	CpuType,cl"		\
	"mov	SysType,ch"		\
	"pop	fs"			\
	modify [eax ebx ecx edx esi];




int main(int argc, char *argv[]) {
	int n,i;

	getmem();
	getinfo();
	printf("    PROG2:  SYS=%02Xh, MEM=%08Xh\n",
		SysType, Mem.FreeLinearSpaceInPages);

	return(0x88);
}
