;*****************************************************************************
; DOS/32 Advanced Example Files Collection
; Copyright (C) 1996-1998 Supernar Systems, Intl.
; All Rights Reserved.
;
; EXCSHOW.ASM
; This program will show how DOS/32 Advanced reports an exception.
; NOTE: this program will not work under external DPMI.
;
; Note the difference:
; If you want to hook an exception in protected mode, you must use DPMI
; functions 0202h and 0203h.
; If you want to hook an interrupt in protected mode, you must use DPMI
; functions 0204h and 0205h.
; For example INT 00h and exception 00h have the same interrupt vector #0,
; but will be processed by different handlers.
;
;*****************************************************************************

	.386p
	.MODEL flat

DGROUP	group _DATA,STACK		; Tasm will complain about STACK here

.CODE
;=============================================================================
start:
	xor	eax,eax
	div	eax			; generate EXC #0, Divide Error

	mov	ax,4C00h		; return to DOS with error code 00h
	int	21h


.DATA
;=============================================================================


.STACK
;=============================================================================
	db	1000h dup(?)


end	start
